# Tuba

[![pipeline status](https://gitlab.com/mathezirkel/tuba/badges/master/pipeline.svg)](https://gitlab.com/mathezirkel/tuba/-/commits/master) [![coverage report](https://gitlab.com/mathezirkel/tuba/badges/master/coverage.svg)](https://gitlab.com/mathezirkel/tuba/-/commits/master)

Tuba stands for _ma**T**hezirkel a**U**gs**B**urg d**A**tabase_.

This library is the backend for all future scripts and GUI tools related to the organization of the Matheschülerzirkel Augsburg and the Mathecamp.

## Usage

TBW

## Build and Run Tests

Requirements:
* A current version of [SBT](https://www.scala-sbt.org/download.html) installed
* JDK (at least version 11) installed, e.g. from [AdoptOpenJDK](https://adoptopenjdk.net/)
* A running Postgresql server, e.g. by running the docker compose file [docker/docker-compose.yml]()

For setting up the DB for integration tests, copy `docker/.env.example` to `/docker/.env`
and modify it appropriately. Then launch Postgresql by executing

```shell
$ cd docker
$ docker-compose up -d
```

In order to configure the integration tests to use the running Postgresql server, copy
`src/it/resources/local.conf.example` to `src/it/resources/local.conf` and modify the file
appropriately. Once the database connection is set up correctly, you can run the tests by executing

```shell
sbt clean test it:test
```

## Release

A new version can be released by adding a Git tag of format like `v1.2.3` and pushing to Gitlab. Also, all commits on `master` are released automatically.

Manual releases are also possible if correct Gitlab credentials are set up. To do so, add a file `~/.sbt/.credentials.gitlab` with the following content:

```dotenv
realm=gitlab
host=https://gitlab.com/
user=Private-Token
password=<API-KEY>
```

The `API-KEY` is a personal Gitlab API access token and needs to have `api` access permissions.

## Licence

Tuba is published under GPL 3, see [LICENCE](LICENSE).